DEF VAR cReportcode      AS CHAR NO-UNDO.
DEF VAR cReportGroup     AS CHAR NO-UNDO.
DEF VAR cReportProcedure AS CHAR NO-UNDO.
DEF VAR iSeqnr           AS INT  NO-UNDO.
DEF VAR iJobnr           AS INT  NO-UNDO.

TRANS_BLOCK:
DO TRANSACTION ON ERROR UNDO TRANS_BLOCK, LEAVE TRANS_BLOCK:
  report:
  FOR EACH wm-report NO-LOCK WHERE 
           LOOKUP(wm-report.reportgroup,"Invoice,Invoice-Test") > 0:
    
    cReportcode      = "".
    cReportGroup     = "".
    cReportProcedure = "".
    
    CASE wm-report.reportgroup:
      WHEN 'Invoice'           THEN cReportGroup = 'WM-INVOICE'.
      WHEN 'Invoice-Test'      THEN cReportGroup = 'WM-INVOICE-TEST'.
      OTHERWISE NEXT report.
    END CASE.

    cReportProcedure = "WM-INVOICE".
    
    iSeqnr = iSeqnr + 1.
    cReportcode = SUBSTRING(cReportGroup,4) + "-" + STRING(iSeqnr,"99").
    
    IF   cReportcode                <> ""
     AND wm-report.reportname       <> ""
    THEN DO:
      CREATE sp-report.
      ASSIGN sp-report.applicationcode     = "WM"
             sp-report.reportcode          = cReportcode
             sp-report.reportgroup         = cReportGroup
             sp-report.reporttype          = "CRYSTAL"
             sp-report.category            = cReportProcedure
             sp-report.reportname          = wm-report.reportname
             sp-report.dataobjectname      = wm-report.dataobjectname
             sp-report.viewerobjectname    = wm-report.viewerobjectname
             sp-report.des                 = wm-report.des
             sp-report.ordernr             = wm-report.ordernr
             sp-report.reportparameters    = wm-report.parameters
             sp-report.old_reportnr        = wm-report.reportnr
             .
      FOR EACH sp-company NO-LOCK:
        FOR EACH wm-address_report NO-LOCK WHERE
                 wm-address_report.companycode = sp-company.companycode
             AND wm-address_report.reportnr    = wm-report.reportnr:
          IF lookup(wm-address_report.reportgroup,"INVOICE,INVOICE-TEST" ) > 0
          THEN DO:
            iJobnr = 0.
            FIND LAST wm-address_report_job WHERE
                      wm-address_report_job.companycode    = sp-company.companycode
                  AND wm-address_report_job.cust_addressnr = wm-address_report.cust_addressnr 
                      NO-LOCK NO-ERROR.
            IF AVAIL wm-address_report_job 
            THEN iJobnr = wm-address_report_job.job_seqnr.
            iJobnr = iJobnr + 1.
            CREATE wm-address_report_job.
            ASSIGN wm-address_report_job.companycode               = sp-company.companycode
                   wm-address_report_job.cust_addressnr            = wm-address_report.cust_addressnr
                   wm-address_report_job.job_seqnr                 = iJobnr
                   wm-address_report_job.schedulerid_code          = sp-company.schedulerid_code
                   wm-address_report_job.applicationcode           = sp-report.applicationcode
                   wm-address_report_job.reportcode                = sp-report.reportcode
                   wm-address_report_job.ind_save                  = wm-report.ind_save
                   wm-address_report_job.ind_custom_values         = FALSE
                   wm-address_report_job.ind_delete_when_completed = FALSE
                   wm-address_report_job.statuscode                = wm-address_report.statuscode
                   wm-address_report_job.reportgroup               = wm-address_report.reportgroup
                   wm-address_report_job.ind_report_print          = TRUE
                   wm-address_report_job.activationcode            = "MANUAL".
          END.
        END.
      END.
    END.
  END.
END.
