DEF BUFFER b-wm-release        FOR wm-release.
DEF BUFFER b-wm-release-update FOR wm-release.

DISABLE TRIGGERS FOR LOAD OF b-wm-release-update.

FOR EACH sp-company NO-LOCK:
  FOR EACH b-wm-release FIELDS(companycode IN_ordnr) NO-LOCK WHERE
           b-wm-release.companycode = sp-company.companycode
       AND b-wm-release.IN_ordnr   >= 90000000
           USE-INDEX IN_ordnr:
    RUN updateRelease.
  END.
  FOR EACH b-wm-release FIELDS(companycode out_ordnr) NO-LOCK WHERE
           b-wm-release.companycode = sp-company.companycode
       AND b-wm-release.out_ordnr   >= 90000000
           USE-INDEX out_ordnr:
    RUN updateRelease.
  END.
END.

PROCEDURE updateRelease:
  
  blok:
  DO TRANSACTION ON ERROR UNDO blok, LEAVE blok:
    FIND b-wm-release-update WHERE
         ROWID(b-wm-release-update) = ROWID(b-wm-release)
         EXCLUSIVE.
    IF b-wm-release-update.out_ordnr >= 90000000
    THEN b-wm-release-update.val_ordnr = b-wm-release-update.out_ordnr - 90000000.
    ELSE b-wm-release-update.val_ordnr = b-wm-release-update.IN_ordnr - 90000000.
    IF b-wm-release-update.out_ordnr > 0
    THEN FIND wm-val_line WHERE
              wm-val_line.companycode = b-wm-release-update.companycode
          AND wm-val_line.out_ordnr   = b-wm-release-update.out_ordnr
          AND wm-val_line.out_linenr  = b-wm-release-update.out_linenr
              USE-INDEX out_linenr NO-LOCK NO-ERROR.
    ELSE FIND wm-val_line WHERE
              wm-val_line.companycode = b-wm-release-update.companycode
          AND wm-val_line.IN_ordnr    = b-wm-release-update.IN_ordnr
          AND wm-val_line.IN_linenr   = b-wm-release-update.IN_linenr
              USE-INDEX in_linenr NO-LOCK NO-ERROR.
    IF AVAIL wm-val_line
    THEN b-wm-release-update.val_linenr = wm-val_line.val_linenr.
  END.

END PROCEDURE.


