DEF BUFFER b-wm-in_ord FOR wm-in_ord.
DISABLE TRIGGERS FOR LOAD OF b-wm-in_ord.
FOR EACH wm-in_ord FIELDS(attachmentnr) NO-LOCK:
  IF wm-in_ord.attachmentnr = 0
  THEN DO:
    RUN newIntakeAttachment.
  END.
END.

DEF BUFFER b-wm-out_ord FOR wm-out_ord.
DISABLE TRIGGERS FOR LOAD OF b-wm-out_ord.
FOR EACH wm-out_ord FIELDS(attachmentnr) NO-LOCK:
  IF wm-out_ord.attachmentnr = 0
  THEN DO:
    RUN newOuttakeAttachment.
  END.
END.

DEF BUFFER b-wm-val_ord FOR wm-val_ord.
DISABLE TRIGGERS FOR LOAD OF b-wm-val_ord.
FOR EACH wm-val_ord FIELDS(attachmentnr) NO-LOCK:
  IF wm-val_ord.attachmentnr = 0
  THEN DO:
    RUN newValAttachment.
  END.
END.

DEF BUFFER b-wm-rel_ord FOR wm-rel_ord.
DISABLE TRIGGERS FOR LOAD OF b-wm-rel_ord.
FOR EACH wm-rel_ord FIELDS(attachmentnr) NO-LOCK:
  IF wm-rel_ord.attachmentnr = 0
  THEN DO:
    RUN newReleaseAttachment.
  END.
END.

PROCEDURE newIntakeAttachment:
  DO TRANSACTION:
    FIND b-wm-in_ord EXCLUSIVE WHERE ROWID(b-wm-in_ord) = ROWID(wm-in_ord).
    b-wm-in_ord.attachmentnr = NEXT-VALUE(aa-attachment).
  END.
END PROCEDURE.

PROCEDURE newOuttakeAttachment:
  DO TRANSACTION:
    FIND b-wm-out_ord EXCLUSIVE WHERE ROWID(b-wm-out_ord) = ROWID(wm-out_ord).
    b-wm-out_ord.attachmentnr = NEXT-VALUE(aa-attachment).
  END.
END PROCEDURE.

PROCEDURE newValAttachment:
  DO TRANSACTION:
    FIND b-wm-val_ord EXCLUSIVE WHERE ROWID(b-wm-val_ord) = ROWID(wm-val_ord).
    b-wm-val_ord.attachmentnr = NEXT-VALUE(aa-attachment).
  END.
END PROCEDURE.

PROCEDURE newReleaseAttachment:
  DO TRANSACTION:
    FIND b-wm-rel_ord EXCLUSIVE WHERE ROWID(b-wm-rel_ord) = ROWID(wm-rel_ord).
    b-wm-rel_ord.attachmentnr = NEXT-VALUE(aa-attachment).
  END.
END PROCEDURE.
