{system/conversion/conversion_progress.i}

DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.
DEF VAR cTerminalCode                 AS CHARACTER NO-UNDO.

ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = "Visitor"
       iTotal   = 0
       iDone    = 0
       cTable   = "wm-visitor".

DISABLE TRIGGERS FOR LOAD OF wm-visitor.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

FIND wm-systemcode NO-LOCK WHERE wm-systemcode.systemtype = "VISITORDOC"
                             AND wm-systemcode.systemcode = "DRVLIC" NO-ERROR.

IF NOT AVAIL wm-systemcode THEN
DO TRANSACTION.
  /*Add visitor document type DRVLIC*/
  CREATE wm-systemcode.
  ASSIGN wm-systemcode.systemtype     = "VISITORDOC"
         wm-systemcode.systemcode     = "DRVLIC"
         wm-systemcode.des            = "Driving License"
         wm-systemcode.ind_input_time = FALSE
         wm-systemcode.ordernr        = 10
         wm-systemcode.internal_code  = wm-systemcode.systemcode.
END.

FIND wm-systemcode NO-LOCK WHERE wm-systemcode.systemtype = "VISITORDOC"
                             AND wm-systemcode.systemcode = "CARGOCARD" NO-ERROR.

IF NOT AVAIL wm-systemcode THEN
DO TRANSACTION.
  /*Add visitor document type CARGOCARD*/
  CREATE wm-systemcode.
  ASSIGN wm-systemcode.systemtype     = "VISITORDOC"
         wm-systemcode.systemcode     = "CARGOCARD"
         wm-systemcode.des            = "Cargo Card"
         wm-systemcode.ind_input_time = FALSE
         wm-systemcode.ordernr        = 10
         wm-systemcode.internal_code  = wm-systemcode.systemcode.
END.

/*Re-order visitor documenttypes*/
FOR EACH wm-systemcode EXCLUSIVE-LOCK WHERE wm-systemcode.systemtype = "VISITORDOC"
                                        AND wm-systemcode.ordernr    > 0.
  CASE wm-systemcode.systemcode:
    WHEN "CARGOCARD" THEN wm-systemcode.ordernr = -10.
    WHEN "DRVLIC"    THEN wm-systemcode.ordernr = -20.
    WHEN "PASSPORT"  THEN wm-systemcode.ordernr = -30.
    WHEN "IDCARD"    THEN wm-systemcode.ordernr = -40.
    WHEN "OTHER"     THEN wm-systemcode.ordernr = -50.
  END CASE.
END.

FOR EACH wm-systemcode EXCLUSIVE-LOCK WHERE wm-systemcode.systemtype = "VISITORDOC"
                                        AND wm-systemcode.ordernr    < 0.
  wm-systemcode.ordernr = wm-systemcode.ordernr * -1.
END.

/*Correct visitor document type*/
FOR EACH wm-visitor EXCLUSIVE-LOCK.
  CASE wm-visitor.document_type:
    WHEN "driving license" THEN wm-visitor.document_type = "DRVLIC".
    WHEN "drivinglicense"  THEN wm-visitor.document_type = "DRVLIC".
    WHEN "DRVLICNL"        THEN wm-visitor.document_type = "DRVLIC".
    WHEN "id-card"         THEN wm-visitor.document_type = "IDCARD".
  END CASE.
  wm-visitor.document_type = CAPS(wm-visitor.document_type).

  iDone = iDone + 1.
  IF iDone MODULO 100 = 0
  THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
END.





RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
