{system/conversion/conversion_progress.i}
DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.

ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = "Blocked orders"
       iTotal   = 0
       iDone    = 0
       cTable   = "wm-blocked".

DEF BUFFER b-wm-blocked FOR wm-blocked.
DISABLE TRIGGERS FOR LOAD OF b-wm-blocked.

DEF BUFFER b-wm-in_ord FOR wm-in_ord.
DISABLE TRIGGERS FOR LOAD OF b-wm-in_ord.
DEF BUFFER b-wm-out_ord FOR wm-out_ord.
DISABLE TRIGGERS FOR LOAD OF b-wm-out_ord.
DEF BUFFER b-wm-rel_ord FOR wm-rel_ord.
DISABLE TRIGGERS FOR LOAD OF b-wm-rel_ord.
DEF BUFFER b-wm-val_ord FOR wm-val_ord.
DISABLE TRIGGERS FOR LOAD OF b-wm-val_ord.
DEF BUFFER b-wm-release FOR wm-release.
DISABLE TRIGGERS FOR LOAD OF b-wm-release.
DEF BUFFER b-wm-stock FOR wm-stock.
DISABLE TRIGGERS FOR LOAD OF b-wm-stock.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

FOR EACH wm-parameter NO-LOCK:
  cAction  = wm-parameter.companycode + " blocked intakes".
  FOR EACH wm-in_ord NO-LOCK WHERE 
           wm-in_ord.companycode = wm-parameter.companycode
       AND wm-in_ord.ordertype   = ""
       AND wm-in_ord.ind_blocked = TRUE
       AND wm-in_ord.block_seqnr = 0:
    DO TRANSACTION:
      FIND b-wm-in_ord EXCLUSIVE WHERE ROWID(b-wm-in_ord) = ROWID(wm-in_ord) NO-ERROR.
      IF AVAIL  b-wm-in_ord
      THEN DO:
        CREATE b-wm-blocked.
        ASSIGN b-wm-blocked.companycode          = wm-in_ord.companycode
               b-wm-blocked.block_seqnr          = NEXT-VALUE(wm-blocked-seq)
               b-wm-blocked.blocked_message      = wm-in_ord.blocked_message
               b-wm-blocked.blocked_messagecode  = wm-in_ord.blocked_messagecode
               b-wm-blocked.dt_blocked           = TODAY
               b-wm-blocked.tim_blocked          = REPLACE(STRING(TIME,"HH:MM"),":","")
               b-wm-blocked.blocked_usercode     = ""
               b-wm-blocked.dt_unblocked         = ?
               b-wm-blocked.tim_unblocked        = ""
               b-wm-blocked.unblocked_usercode   = ""
               b-wm-blocked.ind_inactive         = FALSE
               b-wm-blocked.in_ordnr             = wm-in_ord.IN_ordnr
               b-wm-blocked.cust_addressnr       = wm-in_ord.cust_addressnr.
        ASSIGN b-wm-in_ord.block_seqnr = b-wm-blocked.block_seqnr.
      END.
    END.
    iDone = iDone + 1.
    IF iDone MODULO 100 = 0
    THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.
  
  cAction  = wm-parameter.companycode + " blocked outtakes".
  FOR EACH wm-out_ord NO-LOCK WHERE 
           wm-out_ord.companycode = wm-parameter.companycode
       AND wm-out_ord.ordertype   = ""
       AND wm-out_ord.ind_blocked = TRUE
       AND wm-out_ord.block_seqnr = 0:
    DO TRANSACTION:
      FIND b-wm-out_ord EXCLUSIVE WHERE ROWID(b-wm-out_ord) = ROWID(wm-out_ord) NO-ERROR.
      IF AVAIL  b-wm-out_ord
      THEN DO:
        CREATE b-wm-blocked.
        ASSIGN b-wm-blocked.companycode          = wm-out_ord.companycode
               b-wm-blocked.block_seqnr          = NEXT-VALUE(wm-blocked-seq)
               b-wm-blocked.blocked_message      = wm-out_ord.blocked_message
               b-wm-blocked.blocked_messagecode  = wm-out_ord.blocked_messagecode
               b-wm-blocked.dt_blocked           = TODAY
               b-wm-blocked.tim_blocked          = REPLACE(STRING(TIME,"HH:MM"),":","")
               b-wm-blocked.blocked_usercode     = ""
               b-wm-blocked.dt_unblocked         = ?
               b-wm-blocked.tim_unblocked        = ""
               b-wm-blocked.unblocked_usercode   = ""
               b-wm-blocked.ind_inactive         = FALSE
               b-wm-blocked.out_ordnr            = wm-out_ord.out_ordnr
               b-wm-blocked.cust_addressnr       = wm-out_ord.rec_addressnr.
        ASSIGN b-wm-out_ord.block_seqnr = b-wm-blocked.block_seqnr.
      END.
    END.
    iDone = iDone + 1.
    IF iDone MODULO 100 = 0
    THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.

  cAction  = wm-parameter.companycode + " blocked release".
  FOR EACH wm-rel_ord NO-LOCK WHERE 
           wm-rel_ord.companycode = wm-parameter.companycode
       AND wm-rel_ord.ind_blocked = TRUE
       AND wm-rel_ord.block_seqnr = 0:
    DO TRANSACTION:
      FIND b-wm-rel_ord EXCLUSIVE WHERE ROWID(b-wm-rel_ord) = ROWID(wm-rel_ord) NO-ERROR.
      IF AVAIL  b-wm-rel_ord
      THEN DO:
        CREATE b-wm-blocked.
        ASSIGN b-wm-blocked.companycode          = wm-rel_ord.companycode
               b-wm-blocked.block_seqnr          = NEXT-VALUE(wm-blocked-seq)
               b-wm-blocked.blocked_message      = wm-rel_ord.blocked_message
               b-wm-blocked.blocked_messagecode  = wm-rel_ord.blocked_messagecode
               b-wm-blocked.dt_blocked           = TODAY
               b-wm-blocked.tim_blocked          = REPLACE(STRING(TIME,"HH:MM"),":","")
               b-wm-blocked.blocked_usercode     = ""
               b-wm-blocked.dt_unblocked         = ?
               b-wm-blocked.tim_unblocked        = ""
               b-wm-blocked.unblocked_usercode   = ""
               b-wm-blocked.ind_inactive         = FALSE
               b-wm-blocked.rel_ordnr            = wm-rel_ord.rel_ordnr
               b-wm-blocked.cust_addressnr       = wm-rel_ord.from_cust_addressnr.
        ASSIGN b-wm-rel_ord.block_seqnr = b-wm-blocked.block_seqnr.
      END.
    END.
    iDone = iDone + 1.
    IF iDone MODULO 100 = 0
    THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.
  
  cAction  = wm-parameter.companycode + " blocked val".
  FOR EACH wm-val_ord NO-LOCK WHERE 
           wm-val_ord.companycode = wm-parameter.companycode
       AND wm-val_ord.ind_blocked = TRUE
       AND wm-val_ord.block_seqnr = 0:
    DO TRANSACTION:
      FIND b-wm-val_ord EXCLUSIVE WHERE ROWID(b-wm-val_ord) = ROWID(wm-val_ord) NO-ERROR.
      IF AVAIL  b-wm-val_ord
      THEN DO:
        CREATE b-wm-blocked.
        ASSIGN b-wm-blocked.companycode          = wm-val_ord.companycode
               b-wm-blocked.block_seqnr          = NEXT-VALUE(wm-blocked-seq)
               b-wm-blocked.blocked_message      = wm-val_ord.blocked_message
               b-wm-blocked.blocked_messagecode  = wm-val_ord.blocked_messagecode
               b-wm-blocked.dt_blocked           = TODAY
               b-wm-blocked.tim_blocked          = REPLACE(STRING(TIME,"HH:MM"),":","")
               b-wm-blocked.blocked_usercode     = ""
               b-wm-blocked.dt_unblocked         = ?
               b-wm-blocked.tim_unblocked        = ""
               b-wm-blocked.unblocked_usercode   = ""
               b-wm-blocked.ind_inactive         = FALSE
               b-wm-blocked.val_ordnr            = wm-val_ord.val_ordnr
               b-wm-blocked.cust_addressnr       = wm-val_ord.cust_addressnr.
        ASSIGN b-wm-val_ord.block_seqnr = b-wm-blocked.block_seqnr.
      END.
    END.
    iDone = iDone + 1.
    IF iDone MODULO 100 = 0
    THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.

  cAction  = wm-parameter.companycode + " blocked position".
  FOR EACH wm-release NO-LOCK WHERE 
           wm-release.companycode = wm-parameter.companycode
       AND wm-release.ind_active  = TRUE
       AND wm-release.ind_blocked = TRUE
       AND wm-release.block_seqnr = 0:
    DO TRANSACTION:
      FIND b-wm-release EXCLUSIVE WHERE ROWID(b-wm-release) = ROWID(wm-release) NO-ERROR.
      IF AVAIL  b-wm-release
      THEN DO:
        CREATE b-wm-blocked.
        ASSIGN b-wm-blocked.companycode          = wm-release.companycode
               b-wm-blocked.block_seqnr          = NEXT-VALUE(wm-blocked-seq)
               b-wm-blocked.blocked_message      = wm-release.blocked_message
               b-wm-blocked.blocked_messagecode  = wm-release.blocked_messagecode
               b-wm-blocked.dt_blocked           = TODAY
               b-wm-blocked.tim_blocked          = REPLACE(STRING(TIME,"HH:MM"),":","")
               b-wm-blocked.blocked_usercode     = ""
               b-wm-blocked.dt_unblocked         = ?
               b-wm-blocked.tim_unblocked        = ""
               b-wm-blocked.unblocked_usercode   = ""
               b-wm-blocked.ind_inactive         = FALSE
               b-wm-blocked.releasenr            = wm-release.releasenr
               b-wm-blocked.warehouseref         = wm-release.warehouseref
               b-wm-blocked.cust_addressnr       = wm-release.cust_addressnr.
        ASSIGN b-wm-release.block_seqnr = b-wm-blocked.block_seqnr.
      END.
    END.
    iDone = iDone + 1.
    IF iDone MODULO 100 = 0
    THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.

  cAction  = wm-parameter.companycode + " blocked stock".
  FOR EACH wm-stock NO-LOCK WHERE 
           wm-stock.companycode = wm-parameter.companycode
       AND wm-stock.ind_active  = TRUE
       AND wm-stock.ind_blocked = TRUE
       AND wm-stock.block_seqnr = 0:
    DO TRANSACTION:
      FIND b-wm-stock EXCLUSIVE WHERE ROWID(b-wm-stock) = ROWID(wm-stock) NO-ERROR.
      IF AVAIL  b-wm-stock
      THEN DO:
        CREATE b-wm-blocked.
        ASSIGN b-wm-blocked.companycode          = wm-stock.companycode
               b-wm-blocked.block_seqnr          = NEXT-VALUE(wm-blocked-seq)
               b-wm-blocked.blocked_message      = wm-stock.blocked_message
               b-wm-blocked.blocked_messagecode  = wm-stock.blocked_messagecode
               b-wm-blocked.dt_blocked           = TODAY
               b-wm-blocked.tim_blocked          = REPLACE(STRING(TIME,"HH:MM"),":","")
               b-wm-blocked.blocked_usercode     = ""
               b-wm-blocked.dt_unblocked         = ?
               b-wm-blocked.tim_unblocked        = ""
               b-wm-blocked.unblocked_usercode   = ""
               b-wm-blocked.ind_inactive         = FALSE
               b-wm-blocked.stocknr              = wm-stock.stocknr
               b-wm-blocked.warehouseref         = wm-stock.warehouseref
               b-wm-blocked.barcode_id_internal  = wm-stock.barcode_id_internal
               b-wm-blocked.cust_addressnr       = 0.
        ASSIGN b-wm-stock.block_seqnr = b-wm-blocked.block_seqnr.
      END.
    END.
    iDone = iDone + 1.
    IF iDone MODULO 100 = 0
    THEN RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
  END.

END.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

