{system/conversion/conversion_progress.i}
DEF VAR cProgram                      AS CHARACTER NO-UNDO.
DEF VAR cAction                       AS CHARACTER NO-UNDO.
DEF VAR cTable                        AS CHARACTER NO-UNDO.
DEF VAR iTotal                        AS INTEGER   NO-UNDO.
DEF VAR iDone                         AS INTEGER   NO-UNDO.
DEF VAR cLocation                     AS CHARACTER NO-UNDO.

ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = "WM Gate access control system"
       iTotal   = 0
       iDone    = 0
       cTable   = "wm-ssd_gac_system".

DEF BUFFER b-wm-ssd_gac_system FOR wm-ssd_gac_system.
DEF BUFFER b-wm-ssd_gac        FOR wm-ssd_gac.

DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_gac_system.
DISABLE TRIGGERS FOR LOAD OF b-wm-ssd_gac.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).

FIND b-wm-ssd_gac_system WHERE b-wm-ssd_gac_system.gac_system_code  = "PROTERM" NO-LOCK NO-ERROR.
IF NOT AVAIL b-wm-ssd_gac_system THEN 
DO.
  CREATE b-wm-ssd_gac_system.
  ASSIGN b-wm-ssd_gac_system.gac_system_code  = "PROTERM"
         b-wm-ssd_gac_system.des              = "Proterm SSD interface"
         b-wm-ssd_gac_system.ind_export_vcard = FALSE.
END.


FIND b-wm-ssd_gac_system WHERE b-wm-ssd_gac_system.gac_system_code  = "NET2" NO-LOCK NO-ERROR.
IF NOT AVAIL b-wm-ssd_gac_system THEN 
DO.
  CREATE b-wm-ssd_gac_system.
  ASSIGN b-wm-ssd_gac_system.gac_system_code  = "NET2"
         b-wm-ssd_gac_system.des              = "Net2 gate access control"
         b-wm-ssd_gac_system.ind_export_vcard = TRUE.
END.
       
FIND b-wm-ssd_gac_system WHERE b-wm-ssd_gac_system.gac_system_code  = "CARDACCESS" NO-LOCK NO-ERROR.
IF NOT AVAIL b-wm-ssd_gac_system THEN 
DO.
  CREATE b-wm-ssd_gac_system.
  ASSIGN b-wm-ssd_gac_system.gac_system_code  = "CARDACCESS"
         b-wm-ssd_gac_system.des              = "CardAccess gate access control interface"
         b-wm-ssd_gac_system.ind_export_vcard = TRUE.
END.
       
FIND b-wm-ssd_gac_system WHERE b-wm-ssd_gac_system.gac_system_code  = "AEOS" NO-LOCK NO-ERROR.
IF NOT AVAIL b-wm-ssd_gac_system THEN 
DO.
  CREATE b-wm-ssd_gac_system.
  ASSIGN b-wm-ssd_gac_system.gac_system_code  = "AEOS"
         b-wm-ssd_gac_system.des              = "AEOS gate access control SSD interface"
         b-wm-ssd_gac_system.ind_export_vcard = TRUE.
END.       
       
FOR EACH b-wm-ssd_gac EXCLUSIVE-LOCK.
       IF b-wm-ssd_gac.ssd_gaccode MATCHES "*net2*"       THEN ASSIGN b-wm-ssd_gac.gac_system_code         = "NET2"
                                                                      b-wm-ssd_gac_system.ind_export_vcard = TRUE.
                                                                      
  ELSE IF b-wm-ssd_gac.ssd_gaccode MATCHES "*aeos*"       THEN ASSIGN b-wm-ssd_gac.gac_system_code         = "AEOS"
                                                                      b-wm-ssd_gac.ind_export_vcard = TRUE.
                                                                      
  ELSE IF b-wm-ssd_gac.ssd_gaccode MATCHES "*cardaccess*" THEN ASSIGN b-wm-ssd_gac.gac_system_code         = "CARDACCESS"
                                                                      b-wm-ssd_gac.ind_export_vcard = TRUE.
                                                                      
  ELSE IF b-wm-ssd_gac.ssd_gaccode MATCHES "*proterm*"    THEN ASSIGN b-wm-ssd_gac.gac_system_code         = "PROTERM"
                                                                      b-wm-ssd_gac.ind_export_vcard = FALSE.
END.

iDone  = iDone + 4.
iTotal = iTotal + 4.

RUN DisplayProgress (cProgram, cAction, cTable, iTotal, iDone).
